//
// Created by m on 12/20/21.
//

#ifndef RLA_IIPP_RLENGINEEXCEPTION_HPP
#define RLA_IIPP_RLENGINEEXCEPTION_HPP


#include <exception>
#include <string>
#include <utility>

class RLEngineException : public std::exception {
public:
    [[nodiscard]] const char *what() const _GLIBCXX_TXN_SAFE_DYN _GLIBCXX_NOTHROW override {
        return message.c_str();
    }

    explicit RLEngineException(std::string message) : message(std::move(message)) {}

private:
    std::string message;

};


#endif //RLA_IIPP_RLENGINEEXCEPTION_HPP
